package sam.machine.engine ;      

import java.util.* ; 
import java.util.concurrent.* ; 
import sam.machine.lang.* ; 
import sam.util.* ; 

/**   
  *  ActiveDynamicRewrite is Callable agent for applying 
  *  a dynamic rewrite modulator to a branch using staged inference.
  *  @version 9/10/2021  (in progress ...)
  *     DESIGN DETAILS NEEDED ?????
    */
public class ActiveDynamicRewrite implements ActiveInference { 

   protected final Term idTerm ;             // the rewrite data ?????
   protected final int index ;                   // 1-based index of this rewrite ?????
   protected InferenceManager manager ;          
   //protected int U ;                           // # variables in Lterm of rewrite
   //protected final Functor [] bindings ;         // variable bindings for Lterm
   protected Cache cache ;   

   /**
     *  Construct a static ActiveRewrite which knows its
     *  static Rewrite lang component, and its InferenceManager.
     */
   protected ActiveDynamicRewrite(Term idterm, InferenceManager mngr, int indx) { 
      this.idTerm = idterm ; 
      this.index = indx ;  
      this.manager = mngr ;        
      //this.U = r.U ;               // U == 0 means factual 
      //this.bindings =  new Functor[U] ; 
      this.cache = new Cache() ; 
   }  

// 
//     * Clear entire bindings table 
//      */
//   protected void clear_bindings() { 
//      for (int i = 0 ; i < U ; i++)       
//         bindings[i] = null ;    // now unbound
//   }

   /** 
     * Clear cache 
      */
   protected void clear_cache() { 
      this.cache.clear() ; 
   }


   /** 
     * Call this active dynamic rewrite for 
     * staged saturation inference. 
      */
   public Cache call() {
      // fill in action here
      return this.cache ; 
   } 


} // end ActiveDynamicRewrite

